import os

from setuptools import setup


def read(fname):
    with open(os.path.join(os.path.dirname(__file__), fname)) as buf:
        return buf.read()


setup(
    name="marxbook",
    version="0.0.1",
    description="A flat-file bookmark manager",
    long_description=read("README.md"),
    long_description_content_type="text/markdown",
    author="boyska",
    author_email="piuttosto@logorroici.org",
    license="AGPL",
    packages=["marxbook"],
    install_requires=[
        "beautifulsoup4==4.7.1",
    ],
    python_requires=">=3.5",
    zip_safe=True,
    include_package_data=False,
    entry_points={
        "console_scripts": [
            "mxb=marxbook.cli:main",
        ],
    },
    classifiers=[
        "License :: OSI Approved :: GNU Affero General Public License v3",
        "Programming Language :: Python :: 3.5",
    ],
)
